/*******************************************************************************
 * The MIT License (MIT)
 * 
 * Copyright (c) 2013 Rob Withers
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *  ******************************************************************************
 * Murmur would not be possible without the ideas and implementation of 
 * the erights.org community, which is this software's foundation.  In particular, I 
 * would like to thank the following individuals:
 *         Mark Miller
 *         Marc Stiegler
 *         Bill Franz
 *         Tyler Close 
 *         Kevin Reid
 ******************************************************************************/
package cc.ganymede.utils;

public class IntUtil {

	public static final byte[] intToByteArray(int value) {
		return new byte[] { 
				(byte) (value >>> 24), 
				(byte) (value >>> 16),
				(byte) (value >>> 8), 
				(byte) value };
	}

	public static final int byteArrayToInt(byte[] b) {
		return 
				(b[0] << 24) 
				+ ((b[1] & 0xFF) << 16) 
				+ ((b[2] & 0xFF) << 8) 
				+ (b[3] & 0xFF);
	}

	public static int byteArrayToInt(int[] lengthBytes) {
		return 
				(lengthBytes[0] << 24) 
				+ ((lengthBytes[1] & 0xFF) << 16) 
				+ ((lengthBytes[2] & 0xFF) << 8) 
				+ (lengthBytes[3] & 0xFF);
	}

	public static final byte[] longToByteArray(long value) {
		return new byte[] { 
				(byte) (value >>> 24), 
				(byte) (value >>> 16),
				(byte) (value >>> 8), 
				(byte) value };
	}

	public static final long byteArrayToLong(byte[] b) {
		return 
				((b[0] & 0xffffffffl) << 24) 
				+ ((b[1] & 0xffffffffl) << 16) 
				+ ((b[2] & 0xffffffffl) << 8) 
				+ (b[3] & 0xffffffffl);
	}

	public static long byteArrayToLong(int[] lengthBytes) {
		return 
				((lengthBytes[0] & 0xffffffffl) << 24) 
				+ ((lengthBytes[1] & 0xffffffffl) << 16) 
				+ ((lengthBytes[2] & 0xffffffffl) << 8) 
				+ (lengthBytes[3] & 0xffffffffl);
	}
}
